# Help Us Make Autocode Better

Thanks for your interest in contributing to [Autocode](https://autocode.run).

I'm excited to announce that as of August 3, 2015; we are ready for collaboration on our core codebase as well as our module codebases:

https://github.com/crystal

I have put my heart and soul into developing Autocode and have enjoyed every minute of it. I truly believe it'll change Code Generation (and programming) forever - but in order to get there, I need your help.

Below are the things we need the most. Feel free to email me at [support@autocode.run](mailto:support@autocode.run) if you have any questions and/or feedback.

Thanks again for your help. I know your time is very valuable. I really appreciate every commit, suggestion, feedback and bug report.

Best,
Chris Tate

## What We Need

- **Stars.** One of the easiest ways to help is to star our project. This shows that there is interest for our project and can influence other developers to contribute code.

- **Bug Reports.** Now that there will be more eyes on Autocode, there will likely be issues that are discovered. I will address these issues ASAP.
  - Issues for the [core](ttps://github.com/crystal/autocode) codebase should be reported [here](https://github.com/crystal/autocode/issues).
  - Issues related to specific modules should be reported for their respective repositories which can be found in the sidebar on the module's page (such as https://hub.autocode.run/crystal/handlebars).

- **Modules.** Any language, framework and platform can be modularized into a Spec, Schema, Generator, Engine, Helper, Processor, Transformer and/or Injector. So far, I've created all of Crystal's modules which can be found in the [Crystal Hub](https://hub.autocode.run). All modules are open source and hosted on [GitHub](https://github.com/crystal). Help us improve [crystal/php](https://hub.autocode.run/crystal/php), [crystal/redis](https://hub.autocode.run/crystal/redis), [crystal/sequelize](https://hub.autocode.run/crystal/sequelize) or any of our other 40+ modules. You can even create your own - for your project or someone else's.

- **Documentation.** Our docs are hosted at [https://crystal.readme.io](https://crystal.readme.io). Help us improve them by clicking the "Suggest Edits" link (found on the top-right of each page).

- **Tutorials.** Blogs, videos and more. Tutorials are a great way to learn more about Crystal while helping others in the process.

- **Donations.** Help us fund Autocode and reach our monthly goals here: https://salt.bountysource.com/teams/autocode